
(defun palindrome (x)
       (equal x (rev x))
)

(defun  rev (x)
        (if (null x) x
         (append (rev (cdr x)) (list (car x)))
        )
)

(defun lastnamefirst (nameplusinfo)
       (list (reverse (car nameplusinfo))
             (cadr nameplusinfo))
)

(defun transform (input)
       (mapcar #'lastnamefirst input)
)

(defun decodecomp (msgcomp)
       (if (atom msgcomp)
           msgcomp
	   (if (equal (last msgcomp) '(zzz))
               (cdr (reverse msgcomp))
               msgcomp
           )
        )
)

(defun decode (msg)
       (mapcar #'decodecomp msg)
)


(defun pairup(l)
       (if (null l)
           ()
           (cons (list (car l) (cadr l))
                  (pairup (cddr l))
           )
       )
)


(defun removecursewords (phrase)
       (if (null phrase)
	   '()
	   (let ( (firstword (car phrase))
		  (otherwrds (cdr phrase)) )
	     (if (equal firstword 'hellfire)
	 	 (removecursewords otherwrds)
		 (if (equal firstword 'damnation)
		     (removecursewords otherwrds)
		     (cons firstword (removecursewords otherwrds))
		 )
	     )
	   )
	)
)

(defun prefix (block lst)
	(if (null block)
	    '()
	    (if (null lst)
		'()
		(cons (car lst) (prefix (cdr block) (cdr lst)))
	    )
	)
)

(defun unwrap (ll)
       (uwh (reverse ll) '())
)

(defun uwh (ll rslt)
      (if (null ll)
          rslt
          (uwh (cdr ll) (append (car ll) rslt))
      )
)

(defun groupedintocategories (author libcat)
       (if (null libcat)
           '()
           (cons (select author (cadar libcat))
                 (groupedintocategories author (cdr libcat)))
       )
)

(defun select (author libentries)
       (if (null libentries)
           '()
           (if (equal author (caar libentries))
               (cdar libentries)
               (select author (cdr libentries))
           )
       )
)

(defun worksbyauthor (author libcat)
       (unwrap (groupedintocategories author libcat))
)

(defun catalog ()
       '( (c1 ((a1 b1 b2) (a2 c1 c2)) )
          (c2 ((a1 b3 b4) (a3 d1 d2 d3)) )
          (c3 ((a2 c3 c4) (a3 d4)) )
        )
)

(defun orderp (xglossaryentry yglossaryentry)
       (string-lessp (string (car xglossaryentry))
                     (string (car yglossaryentry))
       )
)

(defun mergesort (seq)
       (if (or (null seq) (null (cdr seq)))
           seq
           (let ( (pair (split seq)))
                (mergee (list (mergesort (car pair))
                              (mergesort (cadr pair))))
           )
        )
)

(defun split (seq)
       (if (null seq)
           '( () () )
           (if (null (cdr seq))
               (list seq '())
               (let ( (pair (split (cddr seq))) )
                    (list (cons (car seq) (car pair))
                          (cons (cadr seq) (cadr pair)))
               )
           )
        )
)

(defun mergee (pair)
      (let ((a (car pair)) (b (cadr pair)))
            (if (null a)
                b
                (if (null b)
                    a
                    (if (orderp (car a) (car b))
                        (cons (car a) (mergee (list (cdr a) b)))
                        (cons (car b) (mergee (list a (cdr b))))
                    )
       )        )
             )
)



(defun sss () '( (table (ttt)) (chair (ccc)) (bed (bbb))))

(defun lasttwo (x lst)
       (if (equal x (car (last lst)))
           (if (equal x (car (last (reverse (cdr (reverse lst))))))
               T
               NIL
           )
       )
)

