
(defun frequencies (text)
       (if (null text)
           '()
           (freq (car text) (frequencies (cdr text)))
)      )

(defun freq (word rslt)
       (if (null rslt)
           (cons (list word 1) '())
           (if (less_than word (caar rslt))
               (cons (list word 1) rslt)
               (if (equal word (caar rslt))
                   (cons (list (caar rslt) (+ (cadar rslt) 1)) (cdr rslt))
                   (cons (car rslt) (freq word (cdr rslt)))
)      )   )   )

(defun less_than (word1 word2)
       (if (string-lessp (string word1) (string word2))
           T
           NIL
)      )


(defun hanoi (n a b c)
       (if (= n 0)
           '()
           (append (hanoi (- n 1) a c b)
                   (list (append '(move disc from) (list a) '(pole to) 
                                  (list c) '(pole)))
                   (hanoi (- n 1) b a c) )
)      )
           
(defun present_in_set (x s)
       (if (null s)
           NIL
           (if (equal x (car s))
               T
               (present_in_set x (cdr s))
)      )   )

(defun union_of_sets (s1 s2)
       (if (null s1)
           s2
           (if (present_in_set (car s1) s2)
               (union_of_sets (cdr s1) s2)
               (cons (car s1) (union_of_sets (cdr s1) s2))
)      )   )

(defun intersection_of_sets (s1 s2)
       (if (null s1)
           '()
           (if (present_in_set (car s1) s2)
               (cons (car s1) (intersection_of_sets (cdr s1) s2))
               (intersection_of_sets (cdr s1) s2)
)      )   )

(defun difference_of_sets (s1 s2)
       (if (null s1)
           '()
           (if (present_in_set (car s1) s2)
               (difference_of_sets (cdr s1) s2)
               (cons (car s1) (difference_of_sets (cdr s1) s2))
)      )   )

