
(defun quicksort (lst)
       (if (null lst)
           '()
           (let ((part (partition (cdr lst) (car lst))))
                (append (quicksort (car part))
                        (list (car lst))
                        (quicksort (cadr part)) )
)      )   )

(defun partition (lst p)
       (if (null lst) 
           '(()())
           (let ((part (partition (cdr lst) p))
                 (first (car lst)))
                (if (less_than first p)
                    (list (cons first (car part))
                          (cadr part))
                    (list (car part)
                          (cons first (cadr part)))
)      )   )    )

(defun less_than (a b)
       (string-lessp (string a) (string b))
)


(defun minmax (lst)
       (if (null lst)
           '(NIL NIL)
           (if (null (cdr lst))
               (cons (car lst) (cons (car lst) '()))
               (let ((pair (split lst)))
                  (let ((mm1 (minmax (car pair)))
                        (mm2 (minmax (cadr pair))))
                       (cons (smaller (car mm1) (car mm2))
                             (cons (larger (cadr mm1) (cadr mm2)) '()))
)      )   )   )  )

(defun smaller (a b)
       (if (less_than a b)
           a
           b
)      )

(defun larger (a b)
       (if (less_than a b)
           b
           a
)      )

(defun split (lst)
       (sph lst '() '())
)

(defun sph (lst rslta rsltb)
       (if (null lst)
           (list rslta rsltb)
           (if (null (cdr lst))
               (list (cons (car lst) rslta) rsltb)
               (sph (cddr lst)
                    (cons (car lst) rslta)
                    (cons (cadr lst) rsltb))
)      )   )


(defun selectionsort (lst)
       (if (null lst)
           '()
           (let ((mm (minmax lst)))
              (cons (car mm) (selectionsort (delete_element (car mm) lst)))
)      )   )

(defun delete_element (e lst)
       (if (null lst)
           lst
           (if (equal (car lst) e)
               (cdr lst)
               (cons (car lst) (delete_element e (cdr lst)))
)      )   )

